
#ifndef _REPCODER_H
#define _REPCODER_H
/***********************************************/

#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif

/*----------- exported functions of REPCODER.DLL ---------*/

BOOL WINAPI repc_init(void);
void WINAPI repc_exit(void);

int WINAPI repc_open_report
  (
   HWND hParent, BOOL bModal, const wchar_t* FormName, int RecordSeqNr,
   int nParams, const int* pParamsNumbers, const wchar_t* const* pParamsValues,
   BOOL bParamsUpdate, BOOL bRecNavigate, BOOL bDesignMode,
   BOOL bAllowDesign, BOOL bAllowUpdate
   );

int WINAPI repc_open_report_a
  (
   HWND hParent, BOOL bModal, const char* FormName, int RecordSeqNr,
   int nParams, const int* pParamsNumbers, const char* const* pParamsValues,
   BOOL bParamsUpdate, BOOL bRecNavigate, BOOL bDesignMode,
   BOOL bAllowDesign, BOOL bAllowUpdate
  );

int WINAPI repc_open_report2
  (
   HWND hParent, BOOL bModal, const wchar_t* FormName, int RecordSeqNr,
   const wchar_t* Parameters,
   BOOL bParamsUpdate, BOOL bRecNavigate, BOOL bDesignMode,
   BOOL bAllowDesign, BOOL bAllowUpdate
   );

int WINAPI repc_open_report2_a
  (
   HWND hParent, BOOL bModal, const char* FormName, int RecordSeqNr,
   const char* Parameters,
   BOOL bParamsUpdate, BOOL bRecNavigate, BOOL bDesignMode,
   BOOL bAllowDesign, BOOL bAllowUpdate
  );

int WINAPI repc_call_report(HWND hParent, BOOL bModal, const wchar_t* FormName, BOOL bDesignMode);
int WINAPI repc_call_report_a(HWND hParent, BOOL bModal, const char* FormName, BOOL bDesignMode);

int WINAPI repc_call_report_param
  (
   HWND hParent, BOOL bModal, const wchar_t* FormName, BOOL bDesignMode,
   int nParams, const int* pParamsNumbers, const wchar_t* const* pParamsValues, BOOL bParamsUpdate
   );

int WINAPI repc_call_report_param_a
  (
   HWND hParent, BOOL bModal, const char* FormName, BOOL bDesignMode,
   int nParams, const int* pParamsNumbers, const char* const* pParamsValues, BOOL bParamsUpdate
  );

int WINAPI repc_call_report_param2
  (
   HWND hParent, BOOL bModal, const wchar_t* FormName, BOOL bDesignMode,
   const wchar_t* Parameters, BOOL bParamsUpdate
   );

int WINAPI repc_call_report_param2_a
  (
   HWND hParent, BOOL bModal, const char* FormName, BOOL bDesignMode,
   const char* Parameters, BOOL bParamsUpdate
  );

void WINAPI repc_explorer(HWND hParent, BOOL bModal, const wchar_t* Dir, BOOL bDesign, BOOL bResultOnly);
void WINAPI repc_explorer_a(HWND hParent, BOOL bModal, const char* Dir, BOOL bDesign, BOOL bResultOnly);

void WINAPI repc_explorer_param
  (
   HWND hParent, BOOL bModal, const wchar_t* Dir, BOOL bDesign, BOOL bResultOnly,
   int nParams, const int* pParamsNumbers, const wchar_t* const* pParamsValues, BOOL bParamsUpdate
  );

void WINAPI repc_explorer_param_a
  (
   HWND hParent, BOOL bModal, const char* Dir, BOOL bDesign, BOOL bResultOnly,
   int nParams, const int* pParamsNumbers, const char* const* pParamsValues, BOOL bParamsUpdate
  );

int WINAPI repc_get_report_desc_len(const wchar_t* FormName);
int WINAPI repc_get_report_desc_len_a(const char* FormName);
BOOL WINAPI repc_get_report_desc(const wchar_t* FormName, wchar_t* buf, int len);
BOOL WINAPI repc_get_report_desc_a(const char* FormName, char* buf, int len);
const wchar_t* WINAPI repc_alloc_report_desc(const wchar_t* FormName);
const char* WINAPI repc_alloc_report_desc_a(const char* FormName);
void WINAPI repc_free_memory(const void* ptr);

int WINAPI repc_get_open_count(void);

BOOL WINAPI repc_can_exit(void);

void WINAPI repc_set_user(const wchar_t* User);
void WINAPI repc_set_user_a(const char* User);

void WINAPI repc_set_pass(const wchar_t* Pass);
void WINAPI repc_set_pass_a(const char* Pass);

void WINAPI repc_set_role(const wchar_t* Role);
void WINAPI repc_set_role_a(const char* Role);

void WINAPI repc_set_charset(const wchar_t* CharSet);
void WINAPI repc_set_charset_a(const char* CharSet);

void WINAPI repc_set_logo(const wchar_t* szLogo, BOOL bReplace);
void WINAPI repc_set_logo_a(const char* szLogo, BOOL bReplace);

BOOL WINAPI repc_get_demo(void);
BOOL WINAPI repc_set_demo(BOOL bDemo);

void WINAPI repc_set_bde_netdir(const wchar_t* dir);
void WINAPI repc_set_bde_netdir_a(const char* dir);

void WINAPI repc_set_fbclient_thread_safe(BOOL bSafe);
void WINAPI repc_set_ibclient_thread_safe(BOOL bSafe);
void WINAPI repc_set_firebird_critical_section(const CRITICAL_SECTION* pCritSec);
void WINAPI repc_set_interbase_critical_section(const CRITICAL_SECTION* pCritSec);

void WINAPI repc_set_external_params_proc(const void* pProc);
void WINAPI repc_set_external_params_proc_a(const void* pProc);
void WINAPI repc_set_external_params_proc_ex(const void* pProc);

void WINAPI repc_set_dialog_fonts(int Type);
void WINAPI repc_set_user_interface_lang(int Lang); /* 0-English, 1-Polish */

BOOL WINAPI repc_create_result(const wchar_t* FormName, const wchar_t* ResultName, const wchar_t* ResultDesc, wchar_t* ErrorBuf, int ErrorBufLen);
BOOL WINAPI repc_create_result_a(const char* FormName, const char* ResultName, const char* ResultDesc, char* ErrorBuf, int ErrorBufLen);

BOOL WINAPI repc_create_result_param(const wchar_t* FormName, const wchar_t* ResultName, const wchar_t* ResultDesc, int nParams, const int* pParamsNumbers, const wchar_t* const* pParamsValues, wchar_t* ErrorBuf, int ErrorBufLen);
BOOL WINAPI repc_create_result_param_a(const char* FormName, const char* ResultName, const char* ResultDesc, int nParams, const int* pParamsNumbers, const char* const* pParamsValues, char* ErrorBuf, int ErrorBufLen);

/*********************** REPCoder Admin *********************/

BOOL WINAPI repc_admin_setup(BOOL bInterBase, const wchar_t* ConnString, const wchar_t* User, const wchar_t* Pass, const wchar_t* ProjectName, const wchar_t* DbName, const wchar_t* DbLogin, const wchar_t* DbPass, const wchar_t* DbRole, BOOL bVerify, BOOL bShowErrorMess);
BOOL WINAPI repc_admin_setup_a(BOOL bInterBase, const char* ConnString, const char* User, const char* Pass, const char* ProjectName, const char* DbName, const char* DbLogin, const char* DbPass, const char* DbRole, BOOL bVerify, BOOL bShowErrorMess);

/*********************** RCALC Module ***********************/

int WINAPI rcalc_alloc_handle(void);
int WINAPI rcalc_copy_handle(int calc_handle);
BOOL WINAPI rcalc_free_handle(int calc_handle);
BOOL WINAPI rcalc_free_all_handles(void);
int WINAPI rcalc_get_state(int calc_handle);
BOOL WINAPI rcalc_is_valid(int calc_handle);
BOOL WINAPI rcalc_is_compiled(int calc_handle);
BOOL WINAPI rcalc_is_executed(int calc_handle);
void WINAPI rcalc_set_status_window(int calc_handle, HWND hStatWnd);
BOOL WINAPI rcalc_compile(int calc_handle, const wchar_t* pText);
BOOL WINAPI rcalc_compile_a(int calc_handle, const char* pText);
BOOL WINAPI rcalc_compile_file(int calc_handle, const wchar_t* FileName, int Format);
BOOL WINAPI rcalc_compile_file_a(int calc_handle, const char* FileName, int Format);
void WINAPI rcalc_show_error(HWND hParent);
int WINAPI rcalc_get_error_text_len(void);
BOOL WINAPI rcalc_copy_error_text(wchar_t* buf, int len);
BOOL WINAPI rcalc_copy_error_text_a(char* buf, int len);
const wchar_t* rcalc_alloc_error_text(void);
const char* rcalc_alloc_error_text_a(void);
int WINAPI rcalc_get_compiled_text_len(int calc_handle, BOOL bCRLF);
BOOL WINAPI rcalc_copy_compiled_text(int calc_handle, BOOL bCRLF, wchar_t* buf, int len);
BOOL WINAPI rcalc_copy_compiled_text_a(int calc_handle, BOOL bCRLF, char* buf, int len);
const wchar_t* WINAPI rcalc_get_compiled_text(int calc_handle, BOOL bCRLF);
const char* WINAPI rcalc_get_compiled_text_a(int calc_handle, BOOL bCRLF);
BOOL WINAPI rcalc_execute(int calc_handle, int nInput, const wchar_t* const* pInputValues);
BOOL WINAPI rcalc_execute_a(int calc_handle, int nInput, const char* const* pInputValues);
BOOL WINAPI rcalc_execute2(int calc_handle, const wchar_t* InputValues, const wchar_t* Separator);
BOOL WINAPI rcalc_execute2_a(int calc_handle, const char* InputValues, const char* Separator);

int WINAPI rcalc_get_input_count(int calc_handle);
int WINAPI rcalc_get_input_name_len(int calc_handle, int number);
BOOL WINAPI rcalc_copy_input_name(int calc_handle, int number, wchar_t* buf, int len);
BOOL WINAPI rcalc_copy_input_name_a(int calc_handle, int number, char* buf, int len);
const wchar_t* WINAPI rcalc_get_input_name(int calc_handle, int number);
const char* WINAPI rcalc_get_input_name_a(int calc_handle, int number);
int WINAPI rcalc_get_input_number(int calc_handle, wchar_t* name);
int WINAPI rcalc_get_input_number_a(int calc_handle, char* name);
int WINAPI rcalc_get_input_type(int calc_handle, int number);
int WINAPI rcalc_get_input_type_numscale(int calc_handle, int number);
int WINAPI rcalc_get_input_type_name_len(int calc_handle, int number);
BOOL WINAPI rcalc_copy_input_type_name(int calc_handle, int number, wchar_t* buf, int len);
BOOL WINAPI rcalc_copy_input_type_name_a(int calc_handle, int number, char* buf, int len);
const wchar_t* WINAPI rcalc_get_input_type_name(int calc_handle, int number);
const char* WINAPI rcalc_get_input_type_name_a(int calc_handle, int number);

int WINAPI rcalc_get_output_count(int calc_handle);
int WINAPI rcalc_get_output_name_len(int calc_handle, int number);
BOOL WINAPI rcalc_copy_output_name(int calc_handle, int number, wchar_t* buf, int len);
BOOL WINAPI rcalc_copy_output_name_a(int calc_handle, int number, char* buf, int len);
const wchar_t* WINAPI rcalc_get_output_name(int calc_handle, int number);
const char* WINAPI rcalc_get_output_name_a(int calc_handle, int number);
int WINAPI rcalc_get_output_number(int calc_handle, const wchar_t* name);
int WINAPI rcalc_get_output_number_a(int calc_handle, const char* name);
int WINAPI rcalc_get_output_type(int calc_handle, int number);
int WINAPI rcalc_get_output_type_textlen(int calc_handle, int number);
int WINAPI rcalc_get_output_type_numscale(int calc_handle, int number);
int WINAPI rcalc_get_output_type_name_len(int calc_handle, int number);
BOOL WINAPI rcalc_copy_output_type_name(int calc_handle, int number, wchar_t* buf, int len);
BOOL WINAPI rcalc_copy_output_type_name_a(int calc_handle, int number, char* buf, int len);
const wchar_t* WINAPI rcalc_get_output_type_name(int calc_handle, int number);
const char* WINAPI rcalc_get_output_type_name_a(int calc_handle, int number);

BOOL WINAPI rcalc_isnull_input(int calc_handle, int number);
const wchar_t* WINAPI rcalc_get_input_string(int calc_handle, int number);
const char* WINAPI rcalc_get_input_string_a(int calc_handle, int number);
int WINAPI rcalc_get_input_string_len(int calc_handle, int number);
int WINAPI rcalc_copy_input_string(int calc_handle, int number, wchar_t* buf, int len);
int WINAPI rcalc_copy_input_string_a(int calc_handle, int number, char* buf, int len);
double WINAPI rcalc_get_input_double(int calc_handle, int number);
int WINAPI rcalc_get_input_int(int calc_handle, int number);
__int64 WINAPI rcalc_get_input_numeric(int calc_handle, int number);
__int64 WINAPI rcalc_get_input_time(int calc_handle, int number);

BOOL WINAPI rcalc_isnull_output(int calc_handle, int number);
const wchar_t* WINAPI rcalc_get_output_string(int calc_handle, int number);
const char* WINAPI rcalc_get_output_string_a(int calc_handle, int number);
int WINAPI rcalc_get_output_string_len(int calc_handle, int number);
int WINAPI rcalc_copy_output_string(int calc_handle, int number, wchar_t* buf, int len);
int WINAPI rcalc_copy_output_string_a(int calc_handle, int number, char* buf, int len);
double WINAPI rcalc_get_output_double(int calc_handle, int number);
int WINAPI rcalc_get_output_int(int calc_handle, int number);
__int64 WINAPI rcalc_get_output_numeric(int calc_handle, int number);
__int64 WINAPI rcalc_get_output_time(int calc_handle, int number);
int WINAPI rcalc_get_year(__int64 value);
int WINAPI rcalc_get_month(__int64 value);
int WINAPI rcalc_get_day(__int64 value);
int WINAPI rcalc_get_hour(__int64 value);
int WINAPI rcalc_get_minute(__int64 value);
int WINAPI rcalc_get_second(__int64 value);
int WINAPI rcalc_get_millisec(__int64 value);

/*********************** ZLIB and IMAGES ********************/

int WINAPI repc_compress(unsigned char* a, unsigned long* b, const unsigned char* c, unsigned long d);
int WINAPI repc_uncompress(unsigned char* a, unsigned long* b, const unsigned char* c, unsigned long d);
HGLOBAL WINAPI repc_load_image(const wchar_t* fname);
HGLOBAL WINAPI repc_load_image_a(const char* fname);
HGLOBAL WINAPI repc_load_image_ptr(const void* ptr, int len);
HGLOBAL WINAPI repc_convert_image(const void* pSrc, int nSrc, int image_type, int jpg_quality);
HGLOBAL WINAPI repc_shrink_image(const void* pSrc, int nSrc, int dest_len, int dest_len_tolerance);
BOOL WINAPI repc_test_connection(int AccessMethod, const wchar_t* ConnStr, const wchar_t* User, const wchar_t* Pass, const wchar_t* Role);

/*--- functions defined in REPCODER.C - load and free REPCODER.DLL ---*/

HINSTANCE repcoder_load(void);
void repcoder_free(void);

/*---------------------------------------------*/

#ifdef __cplusplus
}
#endif

/***********************************************/
#endif
