
/*
compile VC++ (32-bit or 64-bit): cl test_c.cpp repcoder.c user32.lib
compile BCC32: bcc32 test_c.cpp repcoder.c
*/

#include <stdio.h>
#include "repcoder.h"

int main()
{
//--------- Load REPCoder.DLL and call repc_init()

if( !repcoder_load() ) return 0;
if( !repc_init() )
  {
   wprintf(L"repc_init() error ...");
   return 0;
  }
//--------- Call a report without passing parameters

repc_call_report(0 /*hParent*/, 1 /*bModal*/, L".\\Samples\\Report_24 - long memo.sfm", 0 /*bDesignMode*/);

//ANSI version:
//repc_call_report_a(0, 1, ".\\Samples\\Report_24 - long memo.sfm", 0);

//--------- Call a report with passing parameters

int nParams = 2;
int pParamsNumbers[2] = { 1, 3 };
wchar_t* pParamsValues[2] = { L"4", L"Norman" };
int bParamsUpdate = 1;
repc_call_report_param(0, 1, L".\\Samples\\Report_14 - parameters.sfm", 0, nParams, pParamsNumbers, pParamsValues, bParamsUpdate);

//--------- Get the description of a report using: repc_get_report_desc_len, repc_get_report_desc

wchar_t RepName[] = L".\\Samples\\Report_03 - complex.sfm";
int DescLen = repc_get_report_desc_len(RepName);
if( DescLen > 0 )
  {
   wchar_t* pBuf = (wchar_t*)malloc( (DescLen+1)*sizeof(wchar_t) );
   if( pBuf )
     {
      repc_get_report_desc(RepName, pBuf, DescLen+1);
      wprintf(L"Report description 1:\n%s\n\n", pBuf);
      free(pBuf);
     }
  }
//--------- Get the description of a report using: repc_alloc_report_desc, repc_free_memory

const wchar_t* ptr_desc = repc_alloc_report_desc(L".\\Samples\\Report_25 - statistics.sfm");
if( ptr_desc )
  {
   wprintf(L"Report description 2:\n%s\n\n", ptr_desc);
   repc_free_memory(ptr_desc);
  }

//--------- Create a result (SFR file) without opening any user-interface windows

wchar_t ErrorBuf[1024];

BOOL ok = repc_create_result(L".\\Samples\\Report_17 - blobs.sfm", L"fishes.sfr",
L"This is a result\r\ncreated by repc_create_result", ErrorBuf, 1024);

if( ok ) printf("Result file: fishes.sfr was created in the current directory ...\n\n");
else wprintf(L"Error in repc_create_result: %s\n\n", ErrorBuf);

//--------- repc_explorer

repc_explorer(0, 1, L".\\Samples", 1, 0);

//----------- Call repc_exit and Free REPCoder.DLL

repc_exit();
repcoder_free();

return 0;
}

